#ifndef	__SMTP__
#define	__SMTP__

#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>
#include "CMyMutex.h"
#include "Dns.h"
#include "Define.h"
#include "MD5.h"
#include "Base64.h"
#include "ISO2022.h"
#include <TCHAR.H>

#define	SIZE_SMTP_BUF		1400			//SMTPpMޯ̧
#define	SIZE_IMAGE_DAT_READ	54				//摜ްǂݏo
#define	SMTP_RES_WAIT_TIME	3000			//މ҂(~100mSec
#define	TENPUFILE_MAX		255				//Yţٍő吔

typedef struct
{
	//Ă邩Ȃ
	struct
	{
		short iStartup;					//0:WSAStartup()قȂ 1:WSAStartup()ق
	}
	INIT;
	//Ұٻފ֌W
	struct
	{
		short iKind;					//0:SMTP 1:POP before SMTP 2:SMTP Auth
		short iAPOP;					//0:APOPsȂ 1:APOPsȂ
		TCHAR sUserName[256];			//Fհޖ
		TCHAR sPassword[256];			//F߽ܰ
		USHORT iSMTPPortNo;				//SMTP߰Ĕԍ ʏ25
		USHORT iPOP3PortNo;				//POP3߰Ĕԍ ʏ110
		TCHAR sSMTPServerAddress[256];	//SMTPҰٻޱڽ
		TCHAR sPOP3ServerAddress[256];	//POP3Ұٱڽ
	}
	AUTH;
	//M
	struct
	{
		TCHAR sAddress[1024];			//Ұٱڽ;؂ŏ
		TCHAR sCc[1024];				//Ұٱڽ;؂ŏ
		TCHAR sBcc[1024];				//Ұٱڽ;؂ŏ
		TCHAR sSubject[256];			//Ұ
		TCHAR sReply_To[1024];			//Ұٱڽ;؂ŏ
	}
	SEND;
	//̑
	struct
	{
		TCHAR sBoundary[256];			//޳ؕ(łǂ)
		TCHAR sX_MailerName[256];		//Ұװ(łǂ)
		TCHAR sMyHostFQDNName[256];		//νĖ(łǂ)
		TCHAR sMyMailAddress[256];		//Ұٱڽ(łǂ)
		TCHAR sMyMailAddressComt[256];	//Ұٱڽ̍ɺ(łǂ)
	}
	ETC;
	//Yţٖ
	struct
	{
		TCHAR sAppendFile[1024];		//Yţق;؂ŏ
		TCHAR sLog[256];				//۸̧߽
	}
	FILE;
}
SMTP_INI;

// ̧يi[Ӱ
enum
{
	MODE_INT1,
	MODE_WORD1,
	MODE_SHORT1,
	MODE_DWORD1,
	MODE_LONG1,
	MODE_DOUBLE1,
	MODE_STRING1,
	MODE_CHAR1,
	MODE_BOOL1
};
/************************************************************************/
/*						ُ̧									*/
/************************************************************************/
typedef struct
{
	int nMode;								//ӰށiMODE_INTFl@MODE_FLOATF@MODE_STRINGFj
	LPCTSTR pszSection;						//ݖ
	LPCTSTR pszKey;							//
	void* pBuff;							//i[ڽ
}
INIFILE,*PINIFILE;


class CSmtp : public CMyMutex
{
public:
	CSmtp(void);
	~CSmtp(void);
											//SMTPҲ
	long Smtp(LPCTSTR in_ptextMain,LPCTSTR in_pIniFile);
	long Smtp(LPCTSTR in_ptextMain,SMTP_INI* in_pSmtp);

	short pub_SmtpRetCode;					//SMTP

private:
	long SendMail(LPCTSTR in_ptextMain);
	short PropertyCheck(LPTSTR in_lpPropertyName);
											//SMTPM
	BOOL SmtpSnd(SOCKET* pSock, BYTE* pSndBuf, int iSndLen);
											//SMTPڽݽM
	BOOL SmtpRcvRes(SOCKET* pSock, int iVal, int* pResCode);
											//SMTPAUTH(OP25B)ڽݽM
	BYTE SmtpRcvResAuthOP25B(SOCKET* pSock, int iVal, int* pResCode);
	BOOL SmtpRcvResTimeOut(DWORD* pCnt);	//SMTPڽݽѱ
											//POP3F
	BOOL Pop3BeforeSmtp(LPCTSTR pUserName,
						LPCTSTR pPassWord,
						TCHAR* pPop3ServerIpAdr,
						USHORT uiPop3ServerPort);
	BOOL Pop3RcvRes(SOCKET* pSock);			//POP3ڽݽM
											//ѽߎM
	BOOL Pop3RcvTimeStamp(	SOCKET* pSock,
							TCHAR* pTimeStamp,
							int iTimeStampBufSize);
	int SmtpAuth(SOCKET Sock,char* cUserName,char* cPassWord);
	int SmtpAuthOP25B(SOCKET Sock,char* cUserName,char* cPassWord);
	BOOL SmtpRcvTimeStamp(SOCKET* pSock, BYTE* pTimeStamp);
	BOOL SmtpQuitSend(SOCKET* pSock);		//QUITM
	BOOL fnComConvZeroIpAddr(LPTSTR INStr,TCHAR *OUTStr);
	BOOL IpHostJudge(LPTSTR lpStr);
	int	RcptToCommandMake(	SOCKET* Sock,
							LPCTSTR lpRecMailAddress,
							LPCTSTR lpCC,
							LPCTSTR lpBCC);
	LPCTSTR GetContentType(LPCTSTR lpFileName,LPCTSTR lpContentType,LPCTSTR pp);
	int SetFileName(LPCTSTR lpFileName,int* iKosu);
	void OutPutForDebug(TCHAR* pOutPut);
	void ErrorProcess(SOCKET Sock,long lErr,LPCTSTR lpTmp);
	int WideCharToMultiByte(UINT CodePage,
							DWORD dwFlags,
							LPCTSTR lpWideCharStr,
							int cchWideChar,
							LPSTR lpMultiByteStr,
							int cchMultiByte,
							LPCSTR lpDefaultChar,
							LPBOOL lpUsedDefaultChar);
	int MultiByteToWideChar(UINT CodePage,
							DWORD dwFlags,
							LPCSTR lpMultiByteStr,
							int cchMultiByte,
							LPTSTR lpWideCharStr,
							int cchWideChar);
};

#endif
